# coding: utf-8

"""
    CRM cards

    Allows an app to extend the CRM UI by surfacing custom cards in the sidebar of record pages. These cards are defined up-front as part of app configuration, then populated by external data fetch requests when the record page is accessed by a user.  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from hubspot.crm.extensions.cards.configuration import Configuration


class CardResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"id": "str", "created_at": "datetime", "updated_at": "datetime", "title": "str", "fetch": "CardFetchBody", "display": "CardDisplayBody", "actions": "CardActions"}

    attribute_map = {"id": "id", "created_at": "createdAt", "updated_at": "updatedAt", "title": "title", "fetch": "fetch", "display": "display", "actions": "actions"}

    def __init__(self, id=None, created_at=None, updated_at=None, title=None, fetch=None, display=None, actions=None, local_vars_configuration=None):  # noqa: E501
        """CardResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created_at = None
        self._updated_at = None
        self._title = None
        self._fetch = None
        self._display = None
        self._actions = None
        self.discriminator = None

        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        self.title = title
        self.fetch = fetch
        self.display = display
        self.actions = actions

    @property
    def id(self):
        """Gets the id of this CardResponse.  # noqa: E501

        Generated unique ID for card.  # noqa: E501

        :return: The id of this CardResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CardResponse.

        Generated unique ID for card.  # noqa: E501

        :param id: The id of this CardResponse.  # noqa: E501
        :type id: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this CardResponse.  # noqa: E501

        When this card was created.  # noqa: E501

        :return: The created_at of this CardResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this CardResponse.

        When this card was created.  # noqa: E501

        :param created_at: The created_at of this CardResponse.  # noqa: E501
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this CardResponse.  # noqa: E501

        The last time this card was updated.  # noqa: E501

        :return: The updated_at of this CardResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this CardResponse.

        The last time this card was updated.  # noqa: E501

        :param updated_at: The updated_at of this CardResponse.  # noqa: E501
        :type updated_at: datetime
        """

        self._updated_at = updated_at

    @property
    def title(self):
        """Gets the title of this CardResponse.  # noqa: E501

        Displayed title of this card.  # noqa: E501

        :return: The title of this CardResponse.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this CardResponse.

        Displayed title of this card.  # noqa: E501

        :param title: The title of this CardResponse.  # noqa: E501
        :type title: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def fetch(self):
        """Gets the fetch of this CardResponse.  # noqa: E501


        :return: The fetch of this CardResponse.  # noqa: E501
        :rtype: CardFetchBody
        """
        return self._fetch

    @fetch.setter
    def fetch(self, fetch):
        """Sets the fetch of this CardResponse.


        :param fetch: The fetch of this CardResponse.  # noqa: E501
        :type fetch: CardFetchBody
        """
        if self.local_vars_configuration.client_side_validation and fetch is None:  # noqa: E501
            raise ValueError("Invalid value for `fetch`, must not be `None`")  # noqa: E501

        self._fetch = fetch

    @property
    def display(self):
        """Gets the display of this CardResponse.  # noqa: E501


        :return: The display of this CardResponse.  # noqa: E501
        :rtype: CardDisplayBody
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this CardResponse.


        :param display: The display of this CardResponse.  # noqa: E501
        :type display: CardDisplayBody
        """
        if self.local_vars_configuration.client_side_validation and display is None:  # noqa: E501
            raise ValueError("Invalid value for `display`, must not be `None`")  # noqa: E501

        self._display = display

    @property
    def actions(self):
        """Gets the actions of this CardResponse.  # noqa: E501


        :return: The actions of this CardResponse.  # noqa: E501
        :rtype: CardActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this CardResponse.


        :param actions: The actions of this CardResponse.  # noqa: E501
        :type actions: CardActions
        """
        if self.local_vars_configuration.client_side_validation and actions is None:  # noqa: E501
            raise ValueError("Invalid value for `actions`, must not be `None`")  # noqa: E501

        self._actions = actions

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], convert(item[1])), value.items()))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CardResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CardResponse):
            return True

        return self.to_dict() != other.to_dict()
