# coding: utf-8

"""
    Users

    Add, manage, and remove users from your account  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from hubspot.settings.users.configuration import Configuration


class PublicTeam(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"id": "str", "name": "str", "user_ids": "list[str]", "secondary_user_ids": "list[str]"}

    attribute_map = {"id": "id", "name": "name", "user_ids": "userIds", "secondary_user_ids": "secondaryUserIds"}

    def __init__(self, id=None, name=None, user_ids=None, secondary_user_ids=None, local_vars_configuration=None):  # noqa: E501
        """PublicTeam - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._user_ids = None
        self._secondary_user_ids = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.user_ids = user_ids
        self.secondary_user_ids = secondary_user_ids

    @property
    def id(self):
        """Gets the id of this PublicTeam.  # noqa: E501

        The team's unique ID  # noqa: E501

        :return: The id of this PublicTeam.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PublicTeam.

        The team's unique ID  # noqa: E501

        :param id: The id of this PublicTeam.  # noqa: E501
        :type id: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this PublicTeam.  # noqa: E501

        The team's name  # noqa: E501

        :return: The name of this PublicTeam.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PublicTeam.

        The team's name  # noqa: E501

        :param name: The name of this PublicTeam.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def user_ids(self):
        """Gets the user_ids of this PublicTeam.  # noqa: E501

        Primary members of this team  # noqa: E501

        :return: The user_ids of this PublicTeam.  # noqa: E501
        :rtype: list[str]
        """
        return self._user_ids

    @user_ids.setter
    def user_ids(self, user_ids):
        """Sets the user_ids of this PublicTeam.

        Primary members of this team  # noqa: E501

        :param user_ids: The user_ids of this PublicTeam.  # noqa: E501
        :type user_ids: list[str]
        """
        if self.local_vars_configuration.client_side_validation and user_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `user_ids`, must not be `None`")  # noqa: E501

        self._user_ids = user_ids

    @property
    def secondary_user_ids(self):
        """Gets the secondary_user_ids of this PublicTeam.  # noqa: E501

        Secondary or additional members of this team  # noqa: E501

        :return: The secondary_user_ids of this PublicTeam.  # noqa: E501
        :rtype: list[str]
        """
        return self._secondary_user_ids

    @secondary_user_ids.setter
    def secondary_user_ids(self, secondary_user_ids):
        """Sets the secondary_user_ids of this PublicTeam.

        Secondary or additional members of this team  # noqa: E501

        :param secondary_user_ids: The secondary_user_ids of this PublicTeam.  # noqa: E501
        :type secondary_user_ids: list[str]
        """
        if self.local_vars_configuration.client_side_validation and secondary_user_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `secondary_user_ids`, must not be `None`")  # noqa: E501

        self._secondary_user_ids = secondary_user_ids

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], convert(item[1])), value.items()))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicTeam):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PublicTeam):
            return True

        return self.to_dict() != other.to_dict()
